EAPI EAPI_WEAK const Efl_Event_Description _EFL_ACCESS_SELECTION_EVENT_ACCESS_SELECTION_CHANGED =
   EFL_EVENT_DESCRIPTION("access,selection,changed");
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_access_selection_selected_children_count_get, int, 0);
EAPI EAPI_WEAK EFL_FUNC_BODYV_CONST(efl_access_selection_selected_child_get, Efl_Object *, NULL, EFL_FUNC_CALL(selected_child_index), int selected_child_index);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_access_selection_child_select, Eina_Bool, 0, EFL_FUNC_CALL(child_index), int child_index);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_access_selection_selected_child_deselect, Eina_Bool, 0, EFL_FUNC_CALL(child_index), int child_index);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_access_selection_is_child_selected, Eina_Bool, 0, EFL_FUNC_CALL(child_index), int child_index);
EAPI EAPI_WEAK EFL_FUNC_BODY(efl_access_selection_all_children_select, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_FUNC_BODY(efl_access_selection_clear, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_access_selection_child_deselect, Eina_Bool, 0, EFL_FUNC_CALL(child_index), int child_index);

static Eina_Bool
_efl_access_selection_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_ACCESS_SELECTION_EXTRA_OPS
#define EFL_ACCESS_SELECTION_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_access_selection_selected_children_count_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_selected_child_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_child_select, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_selected_child_deselect, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_is_child_selected, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_all_children_select, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_clear, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_selection_child_deselect, NULL),
      EFL_ACCESS_SELECTION_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_access_selection_class_desc = {
   EO_VERSION,
   "Efl.Access.Selection",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_access_selection_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_access_selection_interface_get, &_efl_access_selection_class_desc, NULL, NULL);
